package com.example.pierre.myapplication;

import android.content.Context;
import android.text.Editable;
import android.text.InputType;
import android.text.TextWatcher;
import android.util.AttributeSet;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

/**
 * Class Data
 */
public class Data extends LinearLayout{
    EditText dataEdit;


    public Data(Context context) {
        super(context);
        initEditData();
    }

    public Data(Context context, AttributeSet attrs) {
        super(context, attrs);
        initEditData();
    }

    public Data(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
        initEditData();
    }

    private void initEditData() {
        dataEdit = new EditText(getContext());
        dataEdit.setInputType(InputType.TYPE_TEXT_FLAG_NO_SUGGESTIONS);
        addView(dataEdit, new LinearLayout.LayoutParams(
                LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT, 1));


        dataEdit.addTextChangedListener(new EditDataHexWatcher());
    }

    public void setImeOptions(int imeOptions) {
        dataEdit.setImeOptions(imeOptions | EditorInfo.IME_FLAG_FORCE_ASCII);
    }

    public void setOnEditorActionListener(TextView.OnEditorActionListener l) {
        dataEdit.setOnEditorActionListener(l);
    }

    public byte[] getData() {
        String text = dataEdit.getText().toString();
        return text.getBytes();

    }


    private class EditDataHexWatcher implements TextWatcher {
        @Override
        public void afterTextChanged(Editable s) {
        }

        @Override public void beforeTextChanged(CharSequence s, int start, int count, int after) { }
        @Override public void onTextChanged(CharSequence s, int start, int before, int count) { }
    }
}
