package com.example.pierre.myapplication;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import java.util.List;

/*
 * Class IngredientAdapter : Gestion de la list des éléments
*/

public class IngredientAdapter extends ArrayAdapter<Ingredient> {

    //la liste des models à afficher
    public IngredientAdapter(Context context, List<Ingredient> ingredients) {
        super(context, 0, ingredients);
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        if(convertView == null){
            convertView = LayoutInflater.from(getContext()).inflate(R.layout.row_ingredient, parent, false);
        }

        IngredientViewHolder viewHolder = (IngredientViewHolder) convertView.getTag();
        if(viewHolder == null){
            viewHolder = new IngredientViewHolder();
            viewHolder.description = (TextView) convertView.findViewById(R.id.description);
            viewHolder.text = (TextView) convertView.findViewById(R.id.text);
            convertView.setTag(viewHolder);
        }

        //getItem(position) va récupérer l'item [position] de la List<Ingredient> tweets
        Ingredient ingredient = getItem(position);

        //il ne reste plus qu'à remplir notre vue
        viewHolder.description.setText(ingredient.getDescription());
        viewHolder.text.setText(ingredient.getDlc());

        return convertView;
    }

    private class IngredientViewHolder{
        public TextView description;
        public TextView text;
    }
}
