package com.example.pierre.myapplication;

import java.util.List;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.util.ListIterator;

import android.util.Log;
import android.app.ListActivity;
import android.content.ContentValues;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Button;

/*
 * class listActivity : Gere l'activité list_activity
*/

public class listActivity extends ListActivity {
    private String TAG = "listActivity.java";
    private IngredientManager datasource;
    ListView listview;
    Button add;
    Button delete;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_list);

        datasource = new IngredientManager(this);
        datasource.open();


        listview = (ListView) findViewById(android.R.id.list);
        add = (Button) findViewById(R.id.add);
        delete = (Button) findViewById(R.id.delete);
        add.setOnClickListener(new onChoice());
        delete.setOnClickListener(new onChoice());

        AfficherList();
        //List<Ingredient> values = datasource.getAllComments();
        //IngredientAdapter adapter = new IngredientAdapter(listActivity.this, values);
        //listview.setAdapter(adapter);
    }

    // Sera appelée par l'attribut onClick
    // des boutons déclarés dans activity_list.xml
    public class  onChoice implements View.OnClickListener {

        public void onClick (View view){

            Ingredient ingredient;
            switch (view.getId()) {
                case R.id.add:

                    EditText _desc = (EditText) findViewById(R.id.description);
                    EditText _dlc = (EditText) findViewById(R.id.dlc);
                    Date d = new Date();
                    Log.v(TAG, "Description : " + _desc + "  DLC: " + _dlc);
                    SimpleDateFormat f = new SimpleDateFormat("yyMMddkkmm");
                    String date = f.format(d);
                    datasource.addIngredient(_desc.getText().toString(), _dlc.getText().toString(), date);


                    // enregistrer le nouvel ingredient dans la base de données
                    AfficherList();
                    break;
                case R.id.delete:
                    List<Ingredient> values = datasource.getAllComments();
                    /* if (adapter.getCount() > 0) {
                        ingredient = (Ingredient) adapter.getItem(0);
                        datasource.supIngredient(ingredient);
                        adapter.remove(ingredient);
                    }*/
                    if (!values.isEmpty())
                    {

                        ListIterator li = values.listIterator();
                        datasource.supIngredient((Ingredient) li.next());
                        AfficherList();
                    }
                    break;
            }
        }
    }

    @Override
    protected void onResume() {
        datasource.open();
        super.onResume();
    }

    @Override
    protected void onPause() {
        datasource.close();
        super.onPause();
    }

    public void AfficherList() {
        List<Ingredient> values = datasource.getAllComments();
        // utilisez IngredientAdapter pour afficher les
        // éléments dans une ListView

        IngredientAdapter adapter = new IngredientAdapter(listActivity.this, values);
        listview.setAdapter(adapter);
    }
}
